

(() => {
    const pluginName = "plugin_automessage";

Window_Message.prototype.onEndOfText = function() {
    if (!this.startInput()) {
        if (!this._pauseSkip && !ConfigManager.commandRemember) {
            this.startPause();
        } else if (ConfigManager.commandRemember) {
            this.startPauseAuto();
        } else {
            this.terminateMessage();
        }
    }
    this._textState = null;
};

Window_Message.prototype.startPauseAuto = function() {
    this._waitCountAuto = 60;
    this.pause = true;
};

Window_Message.prototype.updateWait = function() {
    if (Input.isTriggered("control")) {
        ConfigManager.commandRemember = !ConfigManager.commandRemember;
        if (ConfigManager.commandRemember) {
            if (!this._textState) {
                this.startPauseAuto();
            }
        } else {
            this._waitCountAuto == 0;
        }
        ConfigManager.save();
    }
    if (this._waitCountAuto > 0) {
        this._waitCountAuto--;
        if (this._waitCountAuto == 0) {
            this.pause = false;
            this.terminateMessage();
        }
        return true;
    }
    if (this._waitCount > 0) {
        this._waitCount--;
        return true;
    } else {
        return false;
    }
};

var Window_Message_initMembers_org = Window_Message.prototype.initMembers;
Window_Message.prototype.initMembers = function() {
    Window_Message_initMembers_org.apply(this, arguments);
    this._waitCountAuto = 0;
};

var Window__createPauseSignSprites_org = Window.prototype._createPauseSignSprites;
Window.prototype._createPauseSignSprites = function() {
    Window__createPauseSignSprites_org.apply(this, arguments);
    this._autoSprite = new Sprite();
    this.addChild(this._autoSprite);
};

var Window__refreshPauseSign_org = Window.prototype._refreshPauseSign;
Window.prototype._refreshPauseSign = function() {
    Window__refreshPauseSign_org.apply(this, arguments);
    this._autoSprite.bitmap = ImageManager.loadPicture("automsg");
    this._autoSprite.anchor.x = 0;
    this._autoSprite.anchor.y = 1;
    this._autoSprite.move(this._width - 128, this._height - 8);
    this._autoSprite.alpha = 0;
};

var Window__updatePauseSign_org = Window.prototype._updatePauseSign;
Window.prototype._updatePauseSign = function() {
    Window__updatePauseSign_org.apply(this, arguments);
    const sprite = this._autoSprite;
    if (!this.pause) {
        sprite.alpha = 0;
    } else if (!ConfigManager.commandRemember) {
        sprite.alpha = 0;
    } else if (sprite.alpha < 1) {
        sprite.alpha = Math.min(sprite.alpha + 0.1, 1);
    }
    sprite.visible = this.isOpen();
};


})();
