
function OexUtils() {
    throw new Error('This is a static class');
}

(() => {
    const pluginName = "plugin_util";

    //-----------------------------------------------------------------------------
    // Number
    //

    Number.prototype.fluctuate = function(flac) {
        var slip = Math.randomInt(flac * 2) - flac;
        return this + Math.ceil(this * slip / 100);
    };

    Number.prototype.plusRate = function(_rate) {
        return this + Math.floor(this * _rate / 100);
    };

    //-----------------------------------------------------------------------------
    // OexUtils
    //

    OexUtils.randomPop = function(_array) {
      var i = Math.randomInt(_array.length);
      var _data = _array[i];
      _array.splice(i, 1);
      return _data;
    };

    // arrayから重複なしにnum個の要素を取得する。
    OexUtils.randomCollect = function(_array, _num) {
        if (_array.length <= _num) {
            return [].concat(_array);
        }
        var _indexs = [];
        var low_index = 0;
        while (_num > 0) {
            var i = low_index + Math.randomInt(_array.length - _num - low_index + 1);
            _indexs.push(i);
            low_index = i + 1;
            _num -= 1;
        }
        var start_index = Math.randomInt(_array.length);
        var _data = [];
        for (var i = 0; i < _indexs.length; i++) {
            _data.push(_array[(start_index + _indexs[i]) % _array.length]);
        }
        return _data;
    };

    OexUtils.shuffleArray = function(_array) {
      for (let i = _array.length - 1; i > 0; i--) {
        const j = Math.floor(Math.random() * (i + 1));
        var tmp   = _array[i];
        _array[i] = _array[j];
        _array[j] = tmp;
      }
      return _array;
    };

    OexUtils.playSound = function(__name) {
        var se = {"name":__name ,"pan":0,"pitch":100,"volume":90}
        AudioManager.playSe(se);
    };

    OexUtils.playBGM = function(__name) {
        var bgm = {"name":__name ,"pan":0,"pitch":100,"volume":90}
        AudioManager.playBgm(bgm);
    };


    var Scene_Base_update_org = Scene_Base.prototype.update;
    Scene_Base.prototype.update = function() {
        Scene_Base_update_org.apply(this, arguments);
        this.updateLazy();
    };

    Scene_Base.prototype.addLazy = function(frame, fnc) {
        if (this._lazy) {
            this._lazy.push([frame, fnc]);
        } else {
            this._lazy = [];
            this._lazy.push([frame, fnc]);
        }
    };

    Scene_Base.prototype.updateLazy = function(frame, fnc) {
        if (this._lazy) {
            var new_array = [];
            for (let i = 0; i < this._lazy.length; i++) {
                var lzy = this._lazy[i];
                lzy[0] = lzy[0] - 1;
                if (lzy[0] < 0) {
                    lzy[1]();
                } else {
                    new_array.push(lzy);
                }
            }
            this._lazy = new_array;
        }
    };
    




})();
